找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1194|回复: 0

[分享] Breaking a curve at a point

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:11:07 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
//        based on code by Balaji Ramamoorthy
//        http://adndevblog.typepad.com/au ... rve-at-a-point.html
       [CommandMethod("bre")]
        public static void ADSProjectBreak()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Matrix3d ucs = ed.CurrentUserCoordinateSystem;

            Database db = HostApplicationServices.WorkingDatabase;

            ObjectId id;

            Entity ent;

            try
            {
                using (Transaction tr = db.TransactionManager.StartTransaction())
                {
                    BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);

                    // Let the user select a curve   

                    id = ed.GetEntity("\nSelect curve: ").ObjectId;

                    if (id == ObjectId.Null) return;

                    ent = (Entity)tr.GetObject(id, OpenMode.ForRead, false);

                    if (ent == null) return;

                    // Check that it is really a curve   

                    Curve Curve = ent as Curve;

                    if (Curve == null) return;

                    // Get the break position and convert to WC coordinates   

                    Point3d breakPnt;

                    breakPnt = ed.GetPoint("\nPick a point on the curve: ").Value;

                    breakPnt.TransformBy(ucs.Inverse());

                    // Check that the point is on the curve

                    breakPnt = Curve.GetClosestPointTo(breakPnt, false);

                    Point3dCollection breakPoints = new Point3dCollection();

                    DBObjectCollection newCurves = new DBObjectCollection();

                    // Get the segments according to the trim points   

                    breakPoints.Add(breakPnt);

                    newCurves = Curve.GetSplitCurves(breakPoints);

                    if (newCurves == null)
                    {

                        ed.WriteMessage("\nGetSplitCurves failed :  Error");

                        return;

                    }

                    // Here we add the segments to the database with different colors   

                    for (int i = 0; i < newCurves.Count; i++)
                    {

                        Entity pent = (Entity)newCurves as Entity;

                        pent.SetPropertiesFrom(ent);

                        pent.ColorIndex = i + 1;// to display result only

                        btr.AppendEntity(pent);

                        tr.AddNewlyCreatedDBObject(pent, true);

                        tr.TransactionManager.QueueForGraphicsFlush();
                    }

                    ent.UpgradeOpen();

                    ent.Erase();

                    doc.TransactionManager.FlushGraphics();

                    tr.Commit();
                }

            }
            catch (Autodesk.AutoCAD.Runtime.Exception ex)
            {
                Autodesk.AutoCAD.ApplicationServices.Application.ShowAlertDialog(ex.Message + "\n" + ex.StackTrace);
            }
            finally
            {
                ed.WriteMessage("\nPokey");
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:24 , Processed in 0.329688 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表